<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_SearchSegmentsInsurance StructType
 * @subpackage Structs
 */
class JP_SearchSegmentsInsurance extends AbstractStructBase
{
    /**
     * The SearchSegmentInsurance
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_SearchSegmentInsurance
     */
    public $SearchSegmentInsurance;
    /**
     * The CountryOfResidence
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CountryOfResidence;
    /**
     * The Suppliers
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\JP_Suppliers
     */
    public $Suppliers;
    /**
     * The ProductTypes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_ProductType
     */
    public $ProductTypes;
    /**
     * Constructor method for JP_SearchSegmentsInsurance
     * @uses JP_SearchSegmentsInsurance::setSearchSegmentInsurance()
     * @uses JP_SearchSegmentsInsurance::setCountryOfResidence()
     * @uses JP_SearchSegmentsInsurance::setSuppliers()
     * @uses JP_SearchSegmentsInsurance::setProductTypes()
     * @param \StructType\JP_SearchSegmentInsurance $searchSegmentInsurance
     * @param string $countryOfResidence
     * @param \StructType\JP_Suppliers $suppliers
     * @param \ArrayType\ArrayOfJP_ProductType $productTypes
     */
    public function __construct(\StructType\JP_SearchSegmentInsurance $searchSegmentInsurance = null, $countryOfResidence = null, \StructType\JP_Suppliers $suppliers = null, \ArrayType\ArrayOfJP_ProductType $productTypes = null)
    {
        $this
            ->setSearchSegmentInsurance($searchSegmentInsurance)
            ->setCountryOfResidence($countryOfResidence)
            ->setSuppliers($suppliers)
            ->setProductTypes($productTypes);
    }
    /**
     * Get SearchSegmentInsurance value
     * @return \StructType\JP_SearchSegmentInsurance|null
     */
    public function getSearchSegmentInsurance()
    {
        return $this->SearchSegmentInsurance;
    }
    /**
     * Set SearchSegmentInsurance value
     * @param \StructType\JP_SearchSegmentInsurance $searchSegmentInsurance
     * @return \StructType\JP_SearchSegmentsInsurance
     */
    public function setSearchSegmentInsurance(\StructType\JP_SearchSegmentInsurance $searchSegmentInsurance = null)
    {
        $this->SearchSegmentInsurance = $searchSegmentInsurance;
        return $this;
    }
    /**
     * Get CountryOfResidence value
     * @return string|null
     */
    public function getCountryOfResidence()
    {
        return $this->CountryOfResidence;
    }
    /**
     * Set CountryOfResidence value
     * @param string $countryOfResidence
     * @return \StructType\JP_SearchSegmentsInsurance
     */
    public function setCountryOfResidence($countryOfResidence = null)
    {
        // validation for constraint: string
        if (!is_null($countryOfResidence) && !is_string($countryOfResidence)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($countryOfResidence, true), gettype($countryOfResidence)), __LINE__);
        }
        $this->CountryOfResidence = $countryOfResidence;
        return $this;
    }
    /**
     * Get Suppliers value
     * @return \StructType\JP_Suppliers|null
     */
    public function getSuppliers()
    {
        return $this->Suppliers;
    }
    /**
     * Set Suppliers value
     * @param \StructType\JP_Suppliers $suppliers
     * @return \StructType\JP_SearchSegmentsInsurance
     */
    public function setSuppliers(\StructType\JP_Suppliers $suppliers = null)
    {
        $this->Suppliers = $suppliers;
        return $this;
    }
    /**
     * Get ProductTypes value
     * @return \ArrayType\ArrayOfJP_ProductType|null
     */
    public function getProductTypes()
    {
        return $this->ProductTypes;
    }
    /**
     * Set ProductTypes value
     * @param \ArrayType\ArrayOfJP_ProductType $productTypes
     * @return \StructType\JP_SearchSegmentsInsurance
     */
    public function setProductTypes(\ArrayType\ArrayOfJP_ProductType $productTypes = null)
    {
        $this->ProductTypes = $productTypes;
        return $this;
    }
}
